# sample.py
# tkinterのインポート
import tkinter as tk
import tkinter.ttk as ttk
import tkinter.ttk as ttk
import tkinter as tk
import pyxel
from time import sleep
# 自作クラスGameを読み込む
from game import Game

# 画面のサイズ
SCREEN_WIDTH = 800
SCREEN_HEIGHT = 576

def sub_window2():
    import pygame
    pygame.init()
    screen = pygame.display.set_mode((128, 128))
    clock = pygame.time.Clock()

    counter, text = 30, '30'.rjust(3)
    pygame.time.set_timer(pygame.USEREVENT, 1000)
    font = pygame.font.SysFont('Consolas', 30)

    run = True
    while run:
        for e in pygame.event.get():
            if e.type == pygame.USEREVENT: 
                counter -= 1
                text = str(counter).rjust(3) if counter > 0 else 'boom!'
            if e.type == pygame.QUIT: 
                run = False

        screen.fill((255, 255, 255))
        screen.blit(font.render(text, True, (0, 0, 0)), (32, 48))
        pygame.display.flip()
        clock.tick(60)

def sub_window3():
        class App:
            def __init__(self):
                pyxel.init(160, 120, title="Pyxel Jump")
                pyxel.load("image/jump_game1.pyxres")
                self.score = 0
                self.player_x = 72
                self.player_y = -16
                self.player_dy = 0
                self.is_alive = True
                self.far_cloud = [(-10, 75), (40, 65), (90, 60)]
                self.near_cloud = [(10, 25), (70, 35), (120, 15)]
                self.floor = [(i * 60, pyxel.rndi(8, 104), True) for i in range(4)]
                self.fruit = [
                    (i * 60, pyxel.rndi(0, 104), pyxel.rndi(0, 2), True) for i in range(4)
                ]
                pyxel.playm(0, loop=True)
                pyxel.run(self.update, self.draw)

            def update(self):
                if pyxel.btnp(pyxel.KEY_Q):
                    pyxel.quit()

                self.update_player()
                for i, v in enumerate(self.floor):
                    self.floor[i] = self.update_floor(*v)
                for i, v in enumerate(self.fruit):
                    self.fruit[i] = self.update_fruit(*v)

            def update_player(self):
                if pyxel.btn(pyxel.KEY_LEFT) or pyxel.btn(pyxel.GAMEPAD1_BUTTON_DPAD_LEFT):
                    self.player_x = max(self.player_x - 2, 0)
                if pyxel.btn(pyxel.KEY_RIGHT) or pyxel.btn(pyxel.GAMEPAD1_BUTTON_DPAD_RIGHT):
                    self.player_x = min(self.player_x + 2, pyxel.width - 16)
                self.player_y += self.player_dy
                self.player_dy = min(self.player_dy + 1, 8)

                if self.player_y > pyxel.height:
                    if self.is_alive:
                        self.is_alive = False
                        pyxel.play(3, 5)
                    if self.player_y > 600:
                        self.score = 0
                        self.player_x = 72
                        self.player_y = -16
                        self.player_dy = 0
                        self.is_alive = True

            def update_floor(self, x, y, is_alive):
                if is_alive:
                    if (
                        self.player_x + 16 >= x
                        and self.player_x <= x + 40
                        and self.player_y + 16 >= y
                        and self.player_y <= y + 8
                        and self.player_dy > 0
                    ):
                        is_alive = False
                        self.score += 10
                        self.player_dy = -12
                        pyxel.play(3, 3)
                else:
                    y += 6
                x -= 4
                if x < -40:
                    x += 240
                    y = pyxel.rndi(8, 104)
                    is_alive = True
                return x, y, is_alive

            def update_fruit(self, x, y, kind, is_alive):
                if is_alive and abs(x - self.player_x) < 12 and abs(y - self.player_y) < 12:
                    is_alive = False
                    self.score += (kind + 1) * 100
                    self.player_dy = min(self.player_dy, -8)
                    pyxel.play(3, 4)
                x -= 2
                if x < -40:
                    x += 240
                    y = pyxel.rndi(0, 104)
                    kind = pyxel.rndi(0, 2)
                    is_alive = True
                return (x, y, kind, is_alive)

            def draw(self):
                pyxel.cls(12)

                # Draw sky
                pyxel.blt(0, 88, 0, 0, 88, 160, 32)

                # Draw mountain
                pyxel.blt(0, 88, 0, 0, 64, 160, 24, 12)

                # Draw trees
                offset = pyxel.frame_count % 160
                for i in range(2):
                    pyxel.blt(i * 160 - offset, 104, 0, 0, 48, 160, 16, 12)

                # Draw clouds
                offset = (pyxel.frame_count // 16) % 160
                for i in range(2):
                    for x, y in self.far_cloud:
                        pyxel.blt(x + i * 160 - offset, y, 0, 64, 32, 32, 8, 12)
                offset = (pyxel.frame_count // 8) % 160
                for i in range(2):
                    for x, y in self.near_cloud:
                        pyxel.blt(x + i * 160 - offset, y, 0, 0, 32, 56, 8, 12)

                # Draw floors
                for x, y, is_alive in self.floor:
                    pyxel.blt(x, y, 0, 0, 16, 40, 8, 12)

                # Draw fruits
                for x, y, kind, is_alive in self.fruit:
                    if is_alive:
                        pyxel.blt(x, y, 0, 32 + kind * 16, 0, 16, 16, 12)

                # Draw player
                pyxel.blt(
                    self.player_x,
                    self.player_y,
                    0,
                    16 if self.player_dy > 0 else 0,
                    0,
                    16,
                    16,
                    12,
                )

                # Draw score
                s = f"SCORE {self.score:>4}"
                pyxel.text(5, 4, s, 1)
                pyxel.text(4, 4, s, 7)


        App()

def sub_window4():
        import game1

# rootメインウィンドウの設定
root = tk.Tk()
root.title("Home Screen")
root.geometry("300x300")

# メインフレームの作成と設置
frame = tk.Frame(root)
frame.pack(fill = tk.BOTH, padx=5, pady=10)

# 各種ウィジェットの作成
button = ttk.Button(frame, text="タイマーを生成", command=sub_window2)
# 各種ウィジェットの設置
button.pack()


button2=tk.Button(root,text="game1生成",font=("Helvetica",14),command=sub_window4)
button2.place(x=90,y=50)

button3=tk.Button(root,text="game2生成",font=("Helvetica",14),command=sub_window3)
button3.place(x=90,y=110)

labell=tk.Label(root,text=" ※game1で遊べないときには一度このウィンドウを閉じて")
labell.place(x=15,y=180)

labell=tk.Label(root,text="python game1.py と入れてみてください")
labell.place(x=50,y=220)

root.mainloop()

#参考文献
#Copyright (c) 2022 Rakuto Tsumagari
#Released under the LGPL license
#Python Tkinterでテトリスを作ってみる @1219mai0410様
#https://qiita.com/1219mai0410/items/f129559b2d86412e5281
#coding-youtuber/pyxel 直也テック様
#Copyright (c) 2022 Rakuto Tsumagari
#Released under the MIT license
#https://github.com/coding-youtuber/pyxel/blob/master/pyxel/examples/02_jump_game.py
#ソースコードの入手をご希望される方は、津曲へご連絡ください。
#なお、ソースコードの内容等についてのご質問にはお答えいたしかねますので、あらかじめご了承ください。